<?php
namespace Joomla\Component\Jshopping\Administrator\Model;
use Joomla\CMS\Factory;

defined('_JEXEC') or die('Restricted access');


class Check_dbModel extends BaseadminModel{
    
	function errorColumns($data){
		$this->check_alter($this->prefix_table.$data->nameTable, $data->errorColumnsData, $data->errorColumns);
		if (!count($data->errorColumnsData)) return;
		$db = Factory::getDbo();
		$nameTable = "`#__jshopping_".$data->nameTable."`";
		$query = "ALTER TABLE ".$nameTable." ".implode(',',$data->errorColumnsData);
		$db->setQuery($query);
        $db->execute();
	}
	
	function check_alter($nameTable ,&$alter = array(),$columns = array()){
		$db = Factory::getDbo();
		$tablColumn = $this->array_keytolower($db->getTableColumns($nameTable));
		foreach($columns as $key=>$column){
			if (isset($tablColumn[$column])) unset($alter[$key]); 
		}
	}
	
	function array_keytolower($array){
		$columns = array();
		foreach($array as $key=>$rw){
			$columns[strtolower($key)] = $rw;
		}
		return $columns;
	}
	
	function errorColumnsType($data){
		$this->checkColumnType($this->prefix_table.$data->nameTable,$data->errorColumnsType);
		if(!count($data->errorColumnsType))return;
		$db = Factory::getDbo();
		$nameTable = "`#__jshopping_".$data->nameTable."`";
		foreach($data->errorColumnsType as $errorColumnsType){
			$this->checkColumnType($this->prefix_table.$data->nameTable,$data->errorColumnsType);
			$query = "ALTER TABLE ".$nameTable." CHANGE `".$errorColumnsType->name."` `".$errorColumnsType->name."` ".$errorColumnsType->data;
			$db->setQuery($query);
			$db->execute();
		}
	}
	
	function checkColumnType($nameTable,&$alter = array()){
		$db = Factory::getDbo();
		$tablColumn = $this->array_keytolower($db->getTableColumns($nameTable));
		foreach($alter as $key=>$column){
			if($tablColumn[$column->name] == $column->must)unset($alter[$key]); 
		}	
	}
	
	function errorTableCreate($data){
		$db = Factory::getDbo();
		$nameTable = "`#__jshopping_".$data->nameTable."`";
		$rows = array();
		foreach($data->columns as $key=>$row){
			$rows[] = "`".$row."`".$data->columnsData[$key];
		}
		if(count($data->index)){
			$pr_index=array();
			foreach($data->index as $row){
				$pr_index[]="INDEX (`".$row."`)";
			}
			$rows[] = implode(", ",$pr_index);
		}
		if(count($data->primary_key)){
			$pr_key=array();
			foreach($data->primary_key as $row){
				$pr_key[]="`".$row."`";
			}
			$rows[] = "PRIMARY KEY (".implode(", ",$pr_key).")";
		}
		
		if($data->unique_key)$rows[] = "UNIQUE KEY ".$data->unique_key;
		if(count($data->key)){
			foreach($data->key as $row){
				$rows[] = "KEY ".$row;
			}
		}
		$query = 'CREATE TABLE IF NOT EXISTS '.$nameTable."(".implode(",",$rows).")";;
		$db->setQuery($query);
		$db->execute();
	}
	
	function getAllAttribute(){
		$db = Factory::getDbo();
		$query = "SELECT attr_id FROM `#__jshopping_attr` WHERE independent = 0 ";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		foreach($rows as &$row){
			$row->column = "attr_".$row->attr_id;
			$row->columnData = "int(11) NOT NULL";
			$row->columnType = "int";
		}
		return $rows;
	}
	
	function getAllExtra_fields(){
		$db = Factory::getDbo();
		
		$type = array();
		$obj = new \stdClass();
		$obj->type = 'varchar';
		$obj->data = 'varchar(100) NOT NULL';
		$type[1] = $obj;

		$obj = new \stdClass();
		$obj->type = 'varchar';
		$obj->data = 'varchar(32) NOT NULL';
		$type[-1] = $obj;

		$obj = new \stdClass();
		$obj->type = 'int';
		$obj->data = 'int(11) NOT NULL';
		$type[0] = $obj;
		$type[2] = $obj;
		$type[3] = $obj;
		
		$query = "SELECT id, type, multilist FROM `#__jshopping_products_extra_fields`";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		foreach($rows as &$row){
			$row->column = "extra_field_".$row->id;
			$row->columnData = $type[$row->type]->data;
			$row->columnType = $type[$row->type]->type;
			if ($row->type == 0 && $row->multilist) {
				$row->columnData = $type[-1]->data;
				$row->columnType = $type[-1]->type;
			}
			
		}
		
		return $rows;
	}
}